Program Sov2;
Var
 i,f,summ:longint;
procedure Text;                   {печать текста заголовка программы}
var s:byte;
 begin
  writeln(' Натуральное число называется совершенным, если сумма его целых делителей равна');
  write('сaмому числу Cовершенные числа представляются в виде натурального числогого ряда');
  writeln('   Если n+1 -простое число и 2^(n+1)-1 -простое число, тогда s=(2^(n+1)-1)');
  writeln('':15,'┌───────────────────────────────────────────────┐');
  writeln('':15,'│ (2^(n+1)-1)*2^n  =  1 +...+ k + (k+1) +...+ s │');
  writeln('':15,'└───────────────────────────────────────────────┘');
  writeln;
  writeln('В таблице представленны найденные совершенные числа:':65);
  writeln('   ─────┬─────────────┬────────────────────────────────────────────────────');
  writeln('     №  │   Число     │       Другие формы представления этого числа       ');
  writeln('   ─────┼─────────────┼──────────────────┬─────────────────────────────────');

end;{Text}
function Prost(n:longint):boolean;{проверяет числа на простоту}
var i:longint;
 begin
  Prost:=true;
  for i:=2 to trunc(sqrt(n)) do
   begin
    if n mod i=0 then
     begin
      Prost:=false;
      break
     end
   end
end;{Prost}
procedure Rez;                    {печать найденных совершенных чисел}
 begin
  if f<=13 then write(summ:6,'│':3,i div 2*(i-1):10,'   │')
   else write(summ:6,'│':3,'-   ':13,chr(179));
  writeln('(2^':6,f:2,'-1)*2^',f-1:2,'  │  1 +...+ k + (k+1) +...+ ':19,(i-1))
end;{Rez}
procedure Text2;                  {печать текста после завершения вычислений}
 begin
  writeln;
  writeln('Данная программа вычисляет числовой ряд при s<=2^30 = ':65,i*2);
  writeln;
  writeln(' 2^30 максимальное значение, не превосходящее возможных значений из longint ');
  writeln(' Если вместо числа напечатан знак - ,то число превышает максимум из longint ');
  write('End.':79)
end;{Text2}
 {--------------------- *** основная программа *** ------------------------}
Begin
 Text;                            {заголовок}
 for f:=2 to 30 do
  begin
   if not Prost(f) then           {необходимое условие для того, чтобы}
    continue;                     {2^f-1 было простым числом}
   i:=round(exp(f*ln(2)));        {i=2^f; 1+...+s; s=2^f-1}
   if Prost(i-1) then             {i-1 -порстое число}
    begin
     inc(summ);                   {счетчик найденых чисел}
     Rez                          {печать совершенных чисел}
    end
  end;
 writeln('   ─────┴─────────────┴──────────────────┴─────────────────────────────────');
 Text2;                           {текст после вычислений}
 readln
End.